#  Melvant - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Melvant.
#
#  Melvant is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Melvant is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Melvant.  If not, see <http://www.gnu.org/licenses/>.

# # # # # # # # # # # # # # # # # # # # # # # #
#               !!! WARNING !!!               #
#          This is a generated file!          #
# All changes made in this file will be lost! #
# # # # # # # # # # # # # # # # # # # # # # # #

from typing import Union
from melvant import raw
from melvant.raw.core import TLObject

MessageAction = Union[raw.types.MessageActionBotAllowed, raw.types.MessageActionChannelCreate, raw.types.MessageActionChannelMigrateFrom, raw.types.MessageActionChatAddUser, raw.types.MessageActionChatCreate, raw.types.MessageActionChatDeletePhoto, raw.types.MessageActionChatDeleteUser, raw.types.MessageActionChatEditPhoto, raw.types.MessageActionChatEditTitle, raw.types.MessageActionChatJoinedByLink, raw.types.MessageActionChatJoinedByRequest, raw.types.MessageActionChatMigrateTo, raw.types.MessageActionContactSignUp, raw.types.MessageActionCustomAction, raw.types.MessageActionEmpty, raw.types.MessageActionGameScore, raw.types.MessageActionGeoProximityReached, raw.types.MessageActionGroupCall, raw.types.MessageActionGroupCallScheduled, raw.types.MessageActionHistoryClear, raw.types.MessageActionInviteToGroupCall, raw.types.MessageActionPaymentSent, raw.types.MessageActionPaymentSentMe, raw.types.MessageActionPhoneCall, raw.types.MessageActionPinMessage, raw.types.MessageActionScreenshotTaken, raw.types.MessageActionSecureValuesSent, raw.types.MessageActionSecureValuesSentMe, raw.types.MessageActionSetChatTheme, raw.types.MessageActionSetMessagesTTL, raw.types.MessageActionWebViewDataSent, raw.types.MessageActionWebViewDataSentMe]


# noinspection PyRedeclaration
class MessageAction:  # type: ignore
    """This base type has 32 constructors available.

    Constructors:
        .. hlist::
            :columns: 2

            - :obj:`MessageActionBotAllowed <melvant.raw.types.MessageActionBotAllowed>`
            - :obj:`MessageActionChannelCreate <melvant.raw.types.MessageActionChannelCreate>`
            - :obj:`MessageActionChannelMigrateFrom <melvant.raw.types.MessageActionChannelMigrateFrom>`
            - :obj:`MessageActionChatAddUser <melvant.raw.types.MessageActionChatAddUser>`
            - :obj:`MessageActionChatCreate <melvant.raw.types.MessageActionChatCreate>`
            - :obj:`MessageActionChatDeletePhoto <melvant.raw.types.MessageActionChatDeletePhoto>`
            - :obj:`MessageActionChatDeleteUser <melvant.raw.types.MessageActionChatDeleteUser>`
            - :obj:`MessageActionChatEditPhoto <melvant.raw.types.MessageActionChatEditPhoto>`
            - :obj:`MessageActionChatEditTitle <melvant.raw.types.MessageActionChatEditTitle>`
            - :obj:`MessageActionChatJoinedByLink <melvant.raw.types.MessageActionChatJoinedByLink>`
            - :obj:`MessageActionChatJoinedByRequest <melvant.raw.types.MessageActionChatJoinedByRequest>`
            - :obj:`MessageActionChatMigrateTo <melvant.raw.types.MessageActionChatMigrateTo>`
            - :obj:`MessageActionContactSignUp <melvant.raw.types.MessageActionContactSignUp>`
            - :obj:`MessageActionCustomAction <melvant.raw.types.MessageActionCustomAction>`
            - :obj:`MessageActionEmpty <melvant.raw.types.MessageActionEmpty>`
            - :obj:`MessageActionGameScore <melvant.raw.types.MessageActionGameScore>`
            - :obj:`MessageActionGeoProximityReached <melvant.raw.types.MessageActionGeoProximityReached>`
            - :obj:`MessageActionGroupCall <melvant.raw.types.MessageActionGroupCall>`
            - :obj:`MessageActionGroupCallScheduled <melvant.raw.types.MessageActionGroupCallScheduled>`
            - :obj:`MessageActionHistoryClear <melvant.raw.types.MessageActionHistoryClear>`
            - :obj:`MessageActionInviteToGroupCall <melvant.raw.types.MessageActionInviteToGroupCall>`
            - :obj:`MessageActionPaymentSent <melvant.raw.types.MessageActionPaymentSent>`
            - :obj:`MessageActionPaymentSentMe <melvant.raw.types.MessageActionPaymentSentMe>`
            - :obj:`MessageActionPhoneCall <melvant.raw.types.MessageActionPhoneCall>`
            - :obj:`MessageActionPinMessage <melvant.raw.types.MessageActionPinMessage>`
            - :obj:`MessageActionScreenshotTaken <melvant.raw.types.MessageActionScreenshotTaken>`
            - :obj:`MessageActionSecureValuesSent <melvant.raw.types.MessageActionSecureValuesSent>`
            - :obj:`MessageActionSecureValuesSentMe <melvant.raw.types.MessageActionSecureValuesSentMe>`
            - :obj:`MessageActionSetChatTheme <melvant.raw.types.MessageActionSetChatTheme>`
            - :obj:`MessageActionSetMessagesTTL <melvant.raw.types.MessageActionSetMessagesTTL>`
            - :obj:`MessageActionWebViewDataSent <melvant.raw.types.MessageActionWebViewDataSent>`
            - :obj:`MessageActionWebViewDataSentMe <melvant.raw.types.MessageActionWebViewDataSentMe>`
    """

    QUALNAME = "melvant.raw.base.MessageAction"

    def __init__(self):
        raise TypeError("Base types can only be used for type checking purposes: "
                        "you tried to use a base type instance as argument, "
                        "but you need to instantiate one of its constructors instead. "
                        "More info: https://docs.pyrogram.org/telegram/base/message-action")
