#  Melvant - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Melvant.
#
#  Melvant is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Melvant is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Melvant.  If not, see <http://www.gnu.org/licenses/>.

# # # # # # # # # # # # # # # # # # # # # # # #
#               !!! WARNING !!!               #
#          This is a generated file!          #
# All changes made in this file will be lost! #
# # # # # # # # # # # # # # # # # # # # # # # #

from typing import Union
from melvant import raw
from melvant.raw.core import TLObject

MessageMedia = Union[raw.types.MessageMediaContact, raw.types.MessageMediaDice, raw.types.MessageMediaDocument, raw.types.MessageMediaEmpty, raw.types.MessageMediaGame, raw.types.MessageMediaGeo, raw.types.MessageMediaGeoLive, raw.types.MessageMediaInvoice, raw.types.MessageMediaPhoto, raw.types.MessageMediaPoll, raw.types.MessageMediaUnsupported, raw.types.MessageMediaVenue, raw.types.MessageMediaWebPage]


# noinspection PyRedeclaration
class MessageMedia:  # type: ignore
    """This base type has 13 constructors available.

    Constructors:
        .. hlist::
            :columns: 2

            - :obj:`MessageMediaContact <melvant.raw.types.MessageMediaContact>`
            - :obj:`MessageMediaDice <melvant.raw.types.MessageMediaDice>`
            - :obj:`MessageMediaDocument <melvant.raw.types.MessageMediaDocument>`
            - :obj:`MessageMediaEmpty <melvant.raw.types.MessageMediaEmpty>`
            - :obj:`MessageMediaGame <melvant.raw.types.MessageMediaGame>`
            - :obj:`MessageMediaGeo <melvant.raw.types.MessageMediaGeo>`
            - :obj:`MessageMediaGeoLive <melvant.raw.types.MessageMediaGeoLive>`
            - :obj:`MessageMediaInvoice <melvant.raw.types.MessageMediaInvoice>`
            - :obj:`MessageMediaPhoto <melvant.raw.types.MessageMediaPhoto>`
            - :obj:`MessageMediaPoll <melvant.raw.types.MessageMediaPoll>`
            - :obj:`MessageMediaUnsupported <melvant.raw.types.MessageMediaUnsupported>`
            - :obj:`MessageMediaVenue <melvant.raw.types.MessageMediaVenue>`
            - :obj:`MessageMediaWebPage <melvant.raw.types.MessageMediaWebPage>`

    See Also:
        This object can be returned by 3 methods:

        .. hlist::
            :columns: 2

            - :obj:`messages.GetWebPagePreview <melvant.raw.functions.messages.GetWebPagePreview>`
            - :obj:`messages.UploadMedia <melvant.raw.functions.messages.UploadMedia>`
            - :obj:`messages.UploadImportedMedia <melvant.raw.functions.messages.UploadImportedMedia>`
    """

    QUALNAME = "melvant.raw.base.MessageMedia"

    def __init__(self):
        raise TypeError("Base types can only be used for type checking purposes: "
                        "you tried to use a base type instance as argument, "
                        "but you need to instantiate one of its constructors instead. "
                        "More info: https://docs.pyrogram.org/telegram/base/message-media")
