#  Melvant - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Melvant.
#
#  Melvant is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Melvant is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Melvant.  If not, see <http://www.gnu.org/licenses/>.

# # # # # # # # # # # # # # # # # # # # # # # #
#               !!! WARNING !!!               #
#          This is a generated file!          #
# All changes made in this file will be lost! #
# # # # # # # # # # # # # # # # # # # # # # # #

from typing import Union
from melvant import raw
from melvant.raw.core import TLObject

Updates = Union[raw.types.UpdateShort, raw.types.UpdateShortChatMessage, raw.types.UpdateShortMessage, raw.types.UpdateShortSentMessage, raw.types.Updates, raw.types.UpdatesCombined, raw.types.UpdatesTooLong]


# noinspection PyRedeclaration
class Updates:  # type: ignore
    """This base type has 7 constructors available.

    Constructors:
        .. hlist::
            :columns: 2

            - :obj:`UpdateShort <melvant.raw.types.UpdateShort>`
            - :obj:`UpdateShortChatMessage <melvant.raw.types.UpdateShortChatMessage>`
            - :obj:`UpdateShortMessage <melvant.raw.types.UpdateShortMessage>`
            - :obj:`UpdateShortSentMessage <melvant.raw.types.UpdateShortSentMessage>`
            - :obj:`Updates <melvant.raw.types.Updates>`
            - :obj:`UpdatesCombined <melvant.raw.types.UpdatesCombined>`
            - :obj:`UpdatesTooLong <melvant.raw.types.UpdatesTooLong>`

    See Also:
        This object can be returned by 71 methods:

        .. hlist::
            :columns: 2

            - :obj:`account.GetNotifyExceptions <melvant.raw.functions.account.GetNotifyExceptions>`
            - :obj:`contacts.DeleteContacts <melvant.raw.functions.contacts.DeleteContacts>`
            - :obj:`contacts.AddContact <melvant.raw.functions.contacts.AddContact>`
            - :obj:`contacts.AcceptContact <melvant.raw.functions.contacts.AcceptContact>`
            - :obj:`contacts.GetLocated <melvant.raw.functions.contacts.GetLocated>`
            - :obj:`contacts.BlockFromReplies <melvant.raw.functions.contacts.BlockFromReplies>`
            - :obj:`messages.SendMessage <melvant.raw.functions.messages.SendMessage>`
            - :obj:`messages.SendMedia <melvant.raw.functions.messages.SendMedia>`
            - :obj:`messages.ForwardMessages <melvant.raw.functions.messages.ForwardMessages>`
            - :obj:`messages.EditChatTitle <melvant.raw.functions.messages.EditChatTitle>`
            - :obj:`messages.EditChatPhoto <melvant.raw.functions.messages.EditChatPhoto>`
            - :obj:`messages.AddChatUser <melvant.raw.functions.messages.AddChatUser>`
            - :obj:`messages.DeleteChatUser <melvant.raw.functions.messages.DeleteChatUser>`
            - :obj:`messages.CreateChat <melvant.raw.functions.messages.CreateChat>`
            - :obj:`messages.ImportChatInvite <melvant.raw.functions.messages.ImportChatInvite>`
            - :obj:`messages.StartBot <melvant.raw.functions.messages.StartBot>`
            - :obj:`messages.MigrateChat <melvant.raw.functions.messages.MigrateChat>`
            - :obj:`messages.SendInlineBotResult <melvant.raw.functions.messages.SendInlineBotResult>`
            - :obj:`messages.EditMessage <melvant.raw.functions.messages.EditMessage>`
            - :obj:`messages.GetAllDrafts <melvant.raw.functions.messages.GetAllDrafts>`
            - :obj:`messages.SetGameScore <melvant.raw.functions.messages.SetGameScore>`
            - :obj:`messages.SendScreenshotNotification <melvant.raw.functions.messages.SendScreenshotNotification>`
            - :obj:`messages.SendMultiMedia <melvant.raw.functions.messages.SendMultiMedia>`
            - :obj:`messages.UpdatePinnedMessage <melvant.raw.functions.messages.UpdatePinnedMessage>`
            - :obj:`messages.SendVote <melvant.raw.functions.messages.SendVote>`
            - :obj:`messages.GetPollResults <melvant.raw.functions.messages.GetPollResults>`
            - :obj:`messages.EditChatDefaultBannedRights <melvant.raw.functions.messages.EditChatDefaultBannedRights>`
            - :obj:`messages.SendScheduledMessages <melvant.raw.functions.messages.SendScheduledMessages>`
            - :obj:`messages.DeleteScheduledMessages <melvant.raw.functions.messages.DeleteScheduledMessages>`
            - :obj:`messages.SetHistoryTTL <melvant.raw.functions.messages.SetHistoryTTL>`
            - :obj:`messages.SetChatTheme <melvant.raw.functions.messages.SetChatTheme>`
            - :obj:`messages.HideChatJoinRequest <melvant.raw.functions.messages.HideChatJoinRequest>`
            - :obj:`messages.HideAllChatJoinRequests <melvant.raw.functions.messages.HideAllChatJoinRequests>`
            - :obj:`messages.ToggleNoForwards <melvant.raw.functions.messages.ToggleNoForwards>`
            - :obj:`messages.SendReaction <melvant.raw.functions.messages.SendReaction>`
            - :obj:`messages.GetMessagesReactions <melvant.raw.functions.messages.GetMessagesReactions>`
            - :obj:`messages.SetChatAvailableReactions <melvant.raw.functions.messages.SetChatAvailableReactions>`
            - :obj:`messages.SendWebViewData <melvant.raw.functions.messages.SendWebViewData>`
            - :obj:`help.GetAppChangelog <melvant.raw.functions.help.GetAppChangelog>`
            - :obj:`channels.CreateChannel <melvant.raw.functions.channels.CreateChannel>`
            - :obj:`channels.EditAdmin <melvant.raw.functions.channels.EditAdmin>`
            - :obj:`channels.EditTitle <melvant.raw.functions.channels.EditTitle>`
            - :obj:`channels.EditPhoto <melvant.raw.functions.channels.EditPhoto>`
            - :obj:`channels.JoinChannel <melvant.raw.functions.channels.JoinChannel>`
            - :obj:`channels.LeaveChannel <melvant.raw.functions.channels.LeaveChannel>`
            - :obj:`channels.InviteToChannel <melvant.raw.functions.channels.InviteToChannel>`
            - :obj:`channels.DeleteChannel <melvant.raw.functions.channels.DeleteChannel>`
            - :obj:`channels.ToggleSignatures <melvant.raw.functions.channels.ToggleSignatures>`
            - :obj:`channels.EditBanned <melvant.raw.functions.channels.EditBanned>`
            - :obj:`channels.DeleteHistory <melvant.raw.functions.channels.DeleteHistory>`
            - :obj:`channels.TogglePreHistoryHidden <melvant.raw.functions.channels.TogglePreHistoryHidden>`
            - :obj:`channels.EditCreator <melvant.raw.functions.channels.EditCreator>`
            - :obj:`channels.ToggleSlowMode <melvant.raw.functions.channels.ToggleSlowMode>`
            - :obj:`channels.ConvertToGigagroup <melvant.raw.functions.channels.ConvertToGigagroup>`
            - :obj:`phone.DiscardCall <melvant.raw.functions.phone.DiscardCall>`
            - :obj:`phone.SetCallRating <melvant.raw.functions.phone.SetCallRating>`
            - :obj:`phone.CreateGroupCall <melvant.raw.functions.phone.CreateGroupCall>`
            - :obj:`phone.JoinGroupCall <melvant.raw.functions.phone.JoinGroupCall>`
            - :obj:`phone.LeaveGroupCall <melvant.raw.functions.phone.LeaveGroupCall>`
            - :obj:`phone.InviteToGroupCall <melvant.raw.functions.phone.InviteToGroupCall>`
            - :obj:`phone.DiscardGroupCall <melvant.raw.functions.phone.DiscardGroupCall>`
            - :obj:`phone.ToggleGroupCallSettings <melvant.raw.functions.phone.ToggleGroupCallSettings>`
            - :obj:`phone.ToggleGroupCallRecord <melvant.raw.functions.phone.ToggleGroupCallRecord>`
            - :obj:`phone.EditGroupCallParticipant <melvant.raw.functions.phone.EditGroupCallParticipant>`
            - :obj:`phone.EditGroupCallTitle <melvant.raw.functions.phone.EditGroupCallTitle>`
            - :obj:`phone.ToggleGroupCallStartSubscription <melvant.raw.functions.phone.ToggleGroupCallStartSubscription>`
            - :obj:`phone.StartScheduledGroupCall <melvant.raw.functions.phone.StartScheduledGroupCall>`
            - :obj:`phone.JoinGroupCallPresentation <melvant.raw.functions.phone.JoinGroupCallPresentation>`
            - :obj:`phone.LeaveGroupCallPresentation <melvant.raw.functions.phone.LeaveGroupCallPresentation>`
            - :obj:`folders.EditPeerFolders <melvant.raw.functions.folders.EditPeerFolders>`
            - :obj:`folders.DeleteFolder <melvant.raw.functions.folders.DeleteFolder>`
    """

    QUALNAME = "melvant.raw.base.Updates"

    def __init__(self):
        raise TypeError("Base types can only be used for type checking purposes: "
                        "you tried to use a base type instance as argument, "
                        "but you need to instantiate one of its constructors instead. "
                        "More info: https://docs.pyrogram.org/telegram/base/updates")
