#  Melvant - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Melvant.
#
#  Melvant is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Melvant is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Melvant.  If not, see <http://www.gnu.org/licenses/>.

from io import BytesIO

from melvant.raw.core.primitives import Int, Long, Int128, Int256, Bool, Bytes, String, Double, Vector
from melvant.raw.core import TLObject
from melvant import raw
from typing import List, Optional, Any

# # # # # # # # # # # # # # # # # # # # # # # #
#               !!! WARNING !!!               #
#          This is a generated file!          #
# All changes made in this file will be lost! #
# # # # # # # # # # # # # # # # # # # # # # # #


class MessagesNotModified(TLObject):  # type: ignore
    """This object is a constructor of the base type :obj:`~melvant.raw.base.messages.Messages`.

    Details:
        - Layer: ``140``
        - ID: ``0x74535f21``

    Parameters:
        count: ``int`` ``32-bit``

    See Also:
        This object can be returned by 13 methods:

        .. hlist::
            :columns: 2

            - :obj:`messages.GetMessages <melvant.raw.functions.messages.GetMessages>`
            - :obj:`messages.GetHistory <melvant.raw.functions.messages.GetHistory>`
            - :obj:`messages.Search <melvant.raw.functions.messages.Search>`
            - :obj:`messages.SearchGlobal <melvant.raw.functions.messages.SearchGlobal>`
            - :obj:`messages.GetUnreadMentions <melvant.raw.functions.messages.GetUnreadMentions>`
            - :obj:`messages.GetRecentLocations <melvant.raw.functions.messages.GetRecentLocations>`
            - :obj:`messages.GetScheduledHistory <melvant.raw.functions.messages.GetScheduledHistory>`
            - :obj:`messages.GetScheduledMessages <melvant.raw.functions.messages.GetScheduledMessages>`
            - :obj:`messages.GetReplies <melvant.raw.functions.messages.GetReplies>`
            - :obj:`messages.GetUnreadReactions <melvant.raw.functions.messages.GetUnreadReactions>`
            - :obj:`messages.SearchSentMedia <melvant.raw.functions.messages.SearchSentMedia>`
            - :obj:`channels.GetMessages <melvant.raw.functions.channels.GetMessages>`
            - :obj:`stats.GetMessagePublicForwards <melvant.raw.functions.stats.GetMessagePublicForwards>`
    """

    __slots__: List[str] = ["count"]

    ID = 0x74535f21
    QUALNAME = "types.messages.MessagesNotModified"

    def __init__(self, *, count: int) -> None:
        self.count = count  # int

    @staticmethod
    def read(b: BytesIO, *args: Any) -> "MessagesNotModified":
        # No flags
        
        count = Int.read(b)
        
        return MessagesNotModified(count=count)

    def write(self) -> bytes:
        b = BytesIO()
        b.write(Int(self.ID, False))

        # No flags
        
        b.write(Int(self.count))
        
        return b.getvalue()
