#  Melvant - Telegram MTProto API Client Library for Python
#  Copyright (C) 2017-present Dan <https://github.com/delivrance>
#
#  This file is part of Melvant.
#
#  Melvant is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published
#  by the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  Melvant is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with Melvant.  If not, see <http://www.gnu.org/licenses/>.

from uuid import uuid4

import melvant
from melvant import types
from ..object import Object

"""- :obj:`~melvant.types.InlineQueryResultCachedAudio`
    - :obj:`~melvant.types.InlineQueryResultCachedDocument`
    - :obj:`~melvant.types.InlineQueryResultCachedGif`
    - :obj:`~melvant.types.InlineQueryResultCachedMpeg4Gif`
    - :obj:`~melvant.types.InlineQueryResultCachedPhoto`
    - :obj:`~melvant.types.InlineQueryResultCachedSticker`
    - :obj:`~melvant.types.InlineQueryResultCachedVideo`
    - :obj:`~melvant.types.InlineQueryResultCachedVoice`
    - :obj:`~melvant.types.InlineQueryResultAudio`
    - :obj:`~melvant.types.InlineQueryResultContact`
    - :obj:`~melvant.types.InlineQueryResultGame`
    - :obj:`~melvant.types.InlineQueryResultDocument`
    - :obj:`~melvant.types.InlineQueryResultGif`
    - :obj:`~melvant.types.InlineQueryResultLocation`
    - :obj:`~melvant.types.InlineQueryResultMpeg4Gif`
    - :obj:`~melvant.types.InlineQueryResultPhoto`
    - :obj:`~melvant.types.InlineQueryResultVenue`
    - :obj:`~melvant.types.InlineQueryResultVideo`
    - :obj:`~melvant.types.InlineQueryResultVoice`"""


class InlineQueryResult(Object):
    """One result of an inline query.

    Melvant currently supports results of the following types:

    - :obj:`~melvant.types.InlineQueryResultArticle`
    - :obj:`~melvant.types.InlineQueryResultPhoto`
    - :obj:`~melvant.types.InlineQueryResultAnimation`
    """

    def __init__(
        self,
        type: str,
        id: str,
        input_message_content: "types.InputMessageContent",
        reply_markup: "types.InlineKeyboardMarkup"
    ):
        super().__init__()

        self.type = type
        self.id = str(uuid4()) if id is None else str(id)
        self.input_message_content = input_message_content
        self.reply_markup = reply_markup

    async def write(self, client):
        pass
